var Fis20600_RelatoriosCustomizavelImpostosProduto_Controller = function(templateManager, ZhFilterPreferences) {
    
    this.openFilter = function(widget){
        var rowsToSet = {};
        rowsToSet.REPORT = "DC";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };
    
    this.reloadFields = function(widget){
        widget.getField('CDINSCMUNI').reload();
        widget.getField('CDINSCESTA').reload();
    };
    
    this.filter = function(args) {
        //var filterRow = args.e.preference.FILTER_ROW;
        var widget = args.owner;
        var  filterRow = widget.appliedFilter.FILTER_ROW;
        var filtro = [];
        filtro = [
            {
                'name': 'CDINSCESTA',
                'operator': '=',
                'value': (filterRow.CDINSCESTA && filterRow.CDINSCESTA != '') ? filterRow.CDINSCESTA : null
            },
            {
                'name': 'CDINSCMUNI',
                'operator': '=',
                'value': (filterRow.CDINSCMUNI && filterRow.CDINSCMUNI != '') ? filterRow.CDINSCMUNI : null
            },
            {
                'name': 'ENTRSAID',
                'operator': '=',
                'value': (filterRow.ENTRSAID && filterRow.ENTRSAID != '') ? filterRow.ENTRSAID : null
            },
            {
                'name': 'DTINICIAL',
                'operator': '=',
                'value': (filterRow.DATEINTERVAL.start && filterRow.DATEINTERVAL.start != '') ? filterRow.DATEINTERVAL.start : null
            },
            {
                'name': 'DTFINAL',
                'operator': '=',
                'value': (filterRow.DATEINTERVAL.end && filterRow.DATEINTERVAL.end != '') ? filterRow.DATEINTERVAL.end : null
            },
            {
                'name': 'CDFILIAL',
                'operator': '=',
                'value': (filterRow.CDFILIAL && filterRow.CDFILIAL != '') ? filterRow.CDFILIAL : null
            },
            {
                'name': 'CDEMPRESA',
                'operator': '=',
                'value': (filterRow.CDEMPRESA && filterRow.CDEMPRESA != '') ? filterRow.CDEMPRESA : null
            }
        ];
        
        if(filterRow.CDIMPOSTO){
            if(filterRow.CDIMPOSTO.length > 0){
                var filtroCdimposto = '_';
                filterRow.CDIMPOSTO.forEach(function (cdimposto){
                    filtroCdimposto = filtroCdimposto+cdimposto+'_';
                });    
                filtro.push(
                    {
                        "name": "CDIMPOSTO",
                        "operator": "=",
                        "value": filtroCdimposto    
                    }
                );
            }
        }
        
        if (filterRow.CDTIPOOPER){
            var filtroCdtipooper = '_'; 
            for(var i = 0; i < filterRow.CDTIPOOPER.length; ++i) {
                filtroCdtipooper = filtroCdtipooper + filterRow.IDENTRSAIDOP[i] + filterRow.CDTIPOOPER[i] + '_'; 
            }
            filtro.push(
                {
                    "name": "CDTIPOOPER",
                    "operator": "=",
                    "value": filtroCdtipooper    
                }
            );
        }
        
        widget.dataSourceFilter = filtro;
        
        delete filterRow.DATEINTERVAL;
        delete filterRow.REPORT;
        
        
        
        widget.reload();
    };
    
    
  /*  this.filter = function(args) {
        args.e.preventDefault();
        var widget = args.owner;
        var widgetFilter = widget.appliedFilter;
        var filtro = widget.dataSourceFilter;
        widget.getField('CDTIPOOPER').reload();
        widget.getField('CDIMPOSTO').reload();
        
        for (var i = filtro.length - 1; i >= 0; i--) {
            if (filtro[i].name === 'period') {
                filtro.splice(i, 1);
            }
        }

        for (var j = filtro.length - 1; j >= 0; j--) {
            if (filtro[j].name === 'REPORT') {
                filtro.splice(j, 1);
            }
        }

        for (var k = filtro.length - 1; k >= 0; k--) {
            if (filtro[k].name === 'CDIMPOSTO') {
                filtro.splice(k, 1);
            }
        }

        for (var m = filtro.length - 1; m >= 0; m--) {
            if (filtro[m].name === 'CDFILIAL') {
                filtro.splice(m, 1);
            }
        }

        for (var l = filtro.length - 1; l >= 0; l--) {
            if (filtro[l].name === 'NMFILIAL') {
                filtro.splice(l, 1);
            }
        }

        var cdtipooper = widgetFilter.FILTER_ROW.CDTIPOOPER;
        var identrsaidop = widgetFilter.FILTER_ROW.IDENTRSAIDOP;
        var cdtipooperFilter = [];
        
        var entrsaid = false;
        var cdinscmuni = false;
        var cdinscesta = false;
        
        
        if(cdtipooper){
            for (i = 0; i < cdtipooper.length; i++) {
                cdtipooperFilter.push(identrsaidop[i]+cdtipooper[i]);
            }
            cdtipooperFilter = cdtipooperFilter.toString().replace(/,/g, '_');
        }else{
            cdtipooper = false;
        }

        filtro.forEach(function(element) {
            if (element.name === 'ENTRSAID') {
                entrsaid = true;
            } else if (element.name === 'CDINSCMUNI') {
                cdinscmuni = true;
            } else if (element.name === 'CDINSCESTA') {
                cdinscesta = true;
            } else if (element.name === 'start') {
                element.name = 'DTINICIAL';
            } else if (element.name === 'end') {
                element.name = 'DTFINAL';
            } else if (element.name === 'CDTIPOOPER') {
                element.value = cdtipooperFilter;
            }
        });
        
        

        if (!entrsaid && widgetFilter.FILTER_ROW.REPORT === 'DC') {
            filtro.push(
                {
                    "name": "ENTRSAID",
                    "operator": "=",
                    "value": null    
                }
            );
        } else if (widgetFilter.FILTER_ROW.REPORT !== 'DC') {
            for (var s = filtro.length - 1; s >= 0; s--) {
                if (filtro[s].name === 'ENTRSAID') {
                    filtro.splice(s, 1);
                }
            }
        }

        if (!cdinscmuni) {
            filtro.push(
                {
                    "name": "CDINSCMUNI",
                    "operator": "=",
                    "value": null    
                }
            );
        }
        
        if (!cdtipooper){
            filtro.push(
                {
                    "name": "CDTIPOOPER",
                    "operator": "=",
                    "value": null    
                }
            );
        }

        if (!cdinscesta) {
            filtro.push(
                {
                    "name": "CDINSCESTA",
                    "operator": "=",
                    "value": null    
                }
            );
        }

        filtro.push(
            {
                "name": "CDIMPOSTO",
                "operator": "=",
                "value": widgetFilter.FILTER_ROW.CDIMPOSTO ? widgetFilter.FILTER_ROW.CDIMPOSTO.toString().replace(/,/g, '_') : null
            }
        );

        filtro.push(
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widgetFilter.FILTER_ROW.CDFILIAL ? widgetFilter.FILTER_ROW.CDFILIAL.toString().replace(/,/g, '_') : null
            }
        );
        
        widget.getField('DATEINTERVAL').isVisible = false;
        
        widget.reload();
    };
*/
    this.filterRules = function(widget) {
        var empresa = widget.currentRow.CDEMPRESA;
        var fieldMuni = widget.getField('CDINSCMUNI');
        var fieldEstadu = widget.getField('CDINSCESTA');
        
        if (empresa) {
            fieldMuni.readOnly = false;
            fieldEstadu.readOnly = false;
            fieldMuni.reload();
            fieldEstadu.reload();
            fieldMuni.dataSourceFilter[0].value = empresa;
            fieldEstadu.dataSourceFilter[0].value = empresa;
        } else {
            fieldMuni.readOnly = true;
            fieldEstadu.readOnly = true;
            widget.currentRow.CDINSCMUNI = null;
            widget.currentRow.CDINSCESTA = null;
            fieldMuni.dataSourceFilter[0].value = '';
            fieldEstadu.dataSourceFilter[0].value = '';
        }
        
        this.inscrFilterRules(widget);
    };
    
    this.inscrFilterRules = function(widget){
         widget.getField('CDINSCESTA').dataSourceFilter = [{
                                                                    "name": "CDEMPRESA",
                                                                    "operator": "=",
                                                                    "value": widget.currentRow.CDEMPRESA
                                                            }];                            
        
        widget.getField('CDINSCMUNI').dataSourceFilter = [{
                                                                    "name": "CDEMPRESA",
                                                                    "operator": "=",
                                                                    "value": widget.currentRow.CDEMPRESA
                                                            }];
    };

    this.reportRules = function(widget) {
        var widgetGrid = templateManager.container.getWidget('fis20600_grid');
        var report = widget.currentRow.REPORT;
        var fieldTipo = widget.getField('ENTRSAID');
        var fieldImposto = widget.getField('CDIMPOSTO');
        var fieldTipoOpe = widget.getField('CDTIPOOPER');

        if (report === 'DC') {
            fieldTipo.readOnly = false;
            //fieldTipoOpe.readOnly = true;

            fieldImposto.dataSourceFilter = [(
                {
                    "name": "IDFORMAPURNFE",
                    "operator": "<>",
                    "value": "P"    
                }
            )];
            widget.currentRow.CDIMPOSTO = null;
            widget.currentRow.SGIMPOSTONFE = null;
            fieldImposto.reload();

            widgetGrid.dataSource.name = 'fis_relatorios#/impostos_produto';
            widgetGrid.floatingControl.dataSourceName = 'impostos_produto';

        } else {
            if (report === 'DCE') {
                widgetGrid.dataSource.name = 'fis_relatorios#/impostos_produto_entrada';
                widgetGrid.floatingControl.dataSourceName = 'impostos_produto_entrada'; 
                fieldTipoOpe.dataSourceFilter = [
                    {
                        "name": "IDENTRSAIDOP",
                        "operator": "=",
                        "value": "E"
                    }
                ];
            } else if (report === 'DCS') {
                widgetGrid.dataSource.name = 'fis_relatorios#/impostos_produto_saida';
                widgetGrid.floatingControl.dataSourceName = 'impostos_produto_saida'; 
                fieldTipoOpe.dataSourceFilter = [
                    {
                        "name": "IDENTRSAIDOP",
                        "operator": "=",
                        "value": "S"
                    }
                ];
            }

            fieldImposto.dataSourceFilter= [(
                {
                    "name": "IDFORMAPURNFE",
                    "operator": "=",
                    "value": "P"    
                }
            )]  ;
            widget.currentRow.CDIMPOSTO = null;
            widget.currentRow.SGIMPOSTONFE = null;
            fieldImposto.reload();

            fieldTipoOpe.readOnly = false;
            fieldTipoOpe.reload();

            fieldTipo.readOnly = true;
            widget.currentRow.ENTRSAID = null;
        }
        if(widgetGrid.dataSource.data.length === 500)
            delete(widgetGrid.floatingControl);
    };

    this.tipoRules = function(widget) {
        var tipo = widget.currentRow.ENTRSAID;
        var field = widget.getField('CDTIPOOPER');

        if (tipo) {
            field.readOnly = false;
            field.dataSourceFilter = [
                {
                    "name": "IDENTRSAIDOP",
                    "operator": "=",
                    "value": tipo
                }
            ];
            field.reload();

        } else {
            //field.readOnly = true;
            field.dataSourceFilter = [];
        }
        widget.currentRow.CDTIPOOPER = null;  
        widget.currentRow.NMTIPOOPER = null;  
        widget.currentRow.IDENTRSAIDOP = null;
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis20600_RelatoriosCustomizavelImpostosProduto_Controller', Fis20600_RelatoriosCustomizavelImpostosProduto_Controller);
});